package teetime.examples.throughput.methodcall;

import teetime.examples.throughput.methodcall.stage.AbstractStage;
import teetime.util.list.CommittableQueue;

public abstract class ConsumerStage<I, O> extends AbstractStage<I, O> {

	@Override
	public CommittableQueue<O> execute2(final CommittableQueue<I> elements) {
		// the following code block does not harm the performance
		// boolean inputIsEmpty = elements.isEmpty();
		// if (inputIsEmpty) {
		// this.disable();
		// return this.outputElements;
		// }

		CommittableQueue<O> output = super.execute2(elements);
		this.setReschedulable(!elements.isEmpty()); // costs ~1200 ns on chw-work (not reproducible)
		return output;
	}

	@Override
	public void executeWithPorts() {
		I element = this.getInputPort().receive();

		this.setReschedulable(this.getInputPort().pipe.size() > 0);

		this.execute5(element);

		// this.send(result);

		// if (!this.getOutputPort().pipe.isEmpty()) {
		// super.executeWithPorts();
		// }
	}

	@Override
	public void onIsPipelineHead() {
		// do nothing
	}

}
